unit Unit14;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ACBrBase, ACBrECF, ACBrTEFD, ACBrECFClass, ACBrTEFDClass,
  DateUtils, ACBrDevice;

type
  TForm14 = class(TForm)
    ACBrTEFD1: TACBrTEFD;
    ACBrECF1: TACBrECF;
    GroupBox5: TGroupBox;
    btnAbreCupom: TButton;
    btnVendeItem: TButton;
    btnPagamento: TButton;
    btnFechar: TButton;
    GroupBox2: TGroupBox;
    btnExecTEF: TButton;
    btnInicializatef: TButton;
    procedure btnAbreCupomClick(Sender: TObject);
    procedure btnVendeItemClick(Sender: TObject);
    procedure btnPagamentoClick(Sender: TObject);
    procedure btnFecharClick(Sender: TObject);
    procedure ACBrTEFD1ComandaECF(Operacao: TACBrTEFDOperacaoECF;
      Resp: TACBrTEFDResp; var RetornoECF: Integer);
    procedure ACBrTEFD1ComandaECFAbreVinculado(COO, IndiceECF: string;
      Valor: Double; var RetornoECF: Integer);
    procedure ACBrTEFD1ComandaECFImprimeVia(
      TipoRelatorio: TACBrTEFDTipoRelatorio; Via: Integer;
      ImagemComprovante: TStringList; var RetornoECF: Integer);
    procedure ACBrTEFD1ComandaECFPagamento(IndiceECF: string; Valor: Double;
      var RetornoECF: Integer);
    procedure ACBrTEFD1DepoisCancelarTransacoes(
      RespostasPendentes: TACBrTEFDRespostasPendentes);
    procedure ACBrTEFD1DepoisConfirmarTransacoes(
      RespostasPendentes: TACBrTEFDRespostasPendentes);
    procedure ACBrTEFD1ExibeMsg(Operacao: TACBrTEFDOperacaoMensagem;
      Mensagem: string; var AModalResult: TModalResult);
    procedure ACBrTEFD1InfoECF(Operacao: TACBrTEFDInfoECF;
      var RetornoECF: string);
    procedure btnInicializatefClick(Sender: TObject);
    procedure btnExecTEFClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form14: TForm14;

implementation

{$R *.dfm}

procedure TForm14.ACBrTEFD1ComandaECF(Operacao: TACBrTEFDOperacaoECF;
  Resp: TACBrTEFDResp; var RetornoECF: Integer);
begin
try
    case Operacao of
      opeAbreGerencial :
          ACBrECF1.AbreRelatorioGerencial ;

      opeCancelaCupom :
          ACBrECF1.CancelaCupom;

      opeFechaCupom :
         ACBrECF1.FechaCupom('Artigo ActiveDelphi PAF-ECF');

      opeSubTotalizaCupom :
         ACBrECF1.SubtotalizaCupom( 0, 'TEF-PAF-ECF' );

      opeFechaGerencial, opeFechaVinculado :
        ACBrECF1.FechaRelatorio ;

      opePulaLinhas :
        begin
          ACBrECF1.PulaLinhas( ACBrECF1.LinhasEntreCupons );
          ACBrECF1.CortaPapel( True );
          Sleep(200);
        end;
    end;
    RetornoECF := 1 ;
  except
    RetornoECF := 0 ;
  end;
end;

procedure TForm14.ACBrTEFD1ComandaECFAbreVinculado(COO, IndiceECF: string;
  Valor: Double; var RetornoECF: Integer);
begin
  try
   ACBrECF1.AbreCupomVinculado( COO, IndiceECF, Valor );
   RetornoECF := 1 ;
  except
   RetornoECF := 0 ;
  end;
end;

procedure TForm14.ACBrTEFD1ComandaECFImprimeVia(
  TipoRelatorio: TACBrTEFDTipoRelatorio; Via: Integer;
  ImagemComprovante: TStringList; var RetornoECF: Integer);
begin
try
     case TipoRelatorio of
       trGerencial :
         ACBrECF1.LinhaRelatorioGerencial( ImagemComprovante.Text ) ;

       trVinculado :
         ACBrECF1.LinhaCupomVinculado( ImagemComprovante.Text )
     end;

     RetornoECF := 1 ;
  except
     RetornoECF := 0 ;
  end;
end;

procedure TForm14.ACBrTEFD1ComandaECFPagamento(IndiceECF: string; Valor: Double;
  var RetornoECF: Integer);
begin
  //
end;

procedure TForm14.ACBrTEFD1DepoisCancelarTransacoes(
  RespostasPendentes: TACBrTEFDRespostasPendentes);
begin
  //
end;

procedure TForm14.ACBrTEFD1DepoisConfirmarTransacoes(
  RespostasPendentes: TACBrTEFDRespostasPendentes);
begin
//
end;

procedure TForm14.ACBrTEFD1ExibeMsg(Operacao: TACBrTEFDOperacaoMensagem;
  Mensagem: string; var AModalResult: TModalResult);
var
   Fim : TDateTime;
   OldMensagem : String;
begin
  case Operacao of

    opmOK :
       AModalResult := MessageDlg( Mensagem, mtInformation, [mbOK], 0);

    opmYesNo :
       AModalResult := MessageDlg( Mensagem, mtConfirmation, [mbYes,mbNo], 0);

    opmDestaqueVia :
       begin
            { Aguardando 3 segundos }
           Fim := IncSecond( now, 3)  ;
            repeat
               sleep(200) ;
               Application.ProcessMessages;
            until (now > Fim) ;
       end;
  end;
  Application.ProcessMessages;
end;

procedure TForm14.ACBrTEFD1InfoECF(Operacao: TACBrTEFDInfoECF;
  var RetornoECF: string);
begin
     if not ACBrECF1.Ativo then
      ACBrECF1.Ativar;

   case Operacao of
     ineSubTotal :
        RetornoECF := FloatToStr( ACBrECF1.Subtotal-ACBrECF1.TotalPago ) ;

     ineEstadoECF :
       begin
         Case ACBrECF1.Estado of
           estLivre     : RetornoECF := 'L' ;
           estVenda     : RetornoECF := 'V' ;
           estPagamento : RetornoECF := 'P' ;
           estRelatorio : RetornoECF := 'R' ;
         else
           RetornoECF := 'O' ;
         end;
       end;
   end;
end;

procedure TForm14.btnAbreCupomClick(Sender: TObject);
begin
  ACBRECF1.Ativar;
  ACBrECF1.AbreCupom('11111111111','Cliente Fulano','Rua da Alfandega');
end;

procedure TForm14.btnPagamentoClick(Sender: TObject);
var
  Pgto  : TACBrECFFormaPagamento;
begin
  Pgto := ACBrECF1.AchaFPGDescricao('Dinheiro',False,False);
  ACBrECF1.SubtotalizaCupom();
  ACBrECF1.EfetuaPagamento(Pgto.Indice,1.0,'',False);
end;

procedure TForm14.btnVendeItemClick(Sender: TObject);
var
  Aliquota : TACBrECFAliquota;
begin
  Try
    ACBrECf1.VendeItem('001','Item 1','I',1,1.00,0,'UN');
  Except
    On E: Exception do
     begin
      ShowMessage(E.Message);
     end;
  end;
end;

procedure TForm14.btnExecTEFClick(Sender: TObject);
begin
  if ACBrTEFD1.CRT(1,'2',ACBrECF1.NumCOO) then
   begin
    ACBrECF1.SubtotalizaCupom;
    ACBrECF1.EfetuaPagamento('02',1,'',True);
    ACBrECF1.FechaCupom();
   end
  else
    ShowMessage('Erro ao pagar com TEF');

  ACBrTEFD1.ImprimirTransacoesPendentes;
end;

procedure TForm14.btnInicializatefClick(Sender: TObject);
begin
  ACBrTEFD1.TEFDial.Inicializar;
end;

procedure TForm14.btnFecharClick(Sender: TObject);
begin
  ACBrECF1.FechaCupom('Active Delphi');
end;

end.
